﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Animals
{
	abstract class Animal : ISoundable
	{
		// декларираме read-only property
		public string Name
		{
			get
			{
				return this.name;
			}
		}
		private string name;

		// декларираме read-only property
		public bool IsAsleep
		{
			get
			{
				return this.isAsleep;
			}
		}
		private bool isAsleep;

		// декларираме конструктори различими по броя и вида на параметрите им
		protected Animal(string name)
		{
			// никое животно не обича да си остава без име
			if (string.IsNullOrEmpty(name))
				throw new AnimalException("Името на животното не може да е празно!");
			this.name = name;

			Console.WriteLine("Създадох животно с име: " + this.Name);
		}
		protected Animal(string name, bool isAsleep)
		{
			// никое животно не обича да си остава без име
			if (string.IsNullOrEmpty(name))
				throw new AnimalException("Името на животното не може да е празно!");
			this.name = name;
			this.isAsleep = isAsleep;

			Console.WriteLine("Създадох животно с име: " + this.Name);
		}

		// приспиване на животното
		public void Sleep()
		{
			if (this.IsAsleep)
				throw new AnimalException("Животното вече спи.");

			Console.WriteLine("Животното заспа.");
		}

		// събуждане на животното
		public void WakeUp()
		{
			if (this.IsAsleep)
				throw new AnimalException("Животното вече е будно.");

			Console.WriteLine("Животното се събуди.");
		}

		#region ISoundable Members

		public abstract void Sound();

		#endregion
	}
}
