﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Animals
{
	class Program
	{
		static void Main(string[] args)
		{
			Animal animal;

			//! Класът Animal е абстрактен и не може да бъде инстанцииран
			// animal = new Animal("Пепи");
			//! Конструкторите на класа Cat са private и той не може да бъде инстанцииран
			// animal = new Cat("Жорко");

			try
			{
				Animal unnamedAnimal = new Dog(null, true);
				Console.WriteLine(unnamedAnimal.Name);
			}
			catch (AnimalException ex)
			{
				// До дук се стига, когато хвърленото изключение/exception не е прихванато по-рано
				// и е от клас AnimalException или някой от неговите наследници
				Console.WriteLine("Не можах да създам котка, защото: " + ex.Message);
			}
			finally
			{
				// Този код се извиква винаги, с изключение на случаите, когато catch блокът
				// хвърля изключение.
				Console.WriteLine("Въпреки това продължавам работата си!");
			}

			ISoundable soundable;

			// Създаваме куче (Dog) с име "Валери". Трябва да се отбележи, че animal е от
			// клас Animal, т.е. имаме имплицитна (т.е. подразбираща се) смяна на типа (typecast)
			animal = new Dog("Валери");

			// Въпреки имплицитният typecast, истинският тип на създадения обект е известен
			Console.WriteLine("Класът на създаденото животно е: " + animal.GetType());

			soundable = animal as ISoundable;
			soundable.Sound();

			// Създаваме възможно най-голям брой котки, като ги пускаме да подлудят квартала
			// с мяукане:
			for(int i = 0;; i++)
			{
				try
				{
					animal = Cat.CreateCat("Жорко #" + (i + 1));
					animal.Sound();
				}
				catch (AnimalException)
				{
					// ако вече не можем да създадем котка, излизаме от цикъла
					Console.WriteLine("Не стана. Създадох общо " + Cat.TotalCats + " котки!");
					break;
				}
			}

			// Alien класът няма нищо общо с класовете Dog, Cat и Animal, но фактът, че
			// имплементира ISoundable е достатъчен, за да сме сигурни, че има метод Sound().
			Alien alien = new Alien();
			soundable = alien as ISoundable;
			soundable.Sound();

			Console.ReadKey();
		}
	}
}
